package org.simantics.db.layer0.variable;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Set;

import org.simantics.databoard.binding.Binding;

public class ConstantPropertyVariableBuilder {

    final String name;
    final Object value;
    final Binding binding;
    final Collection<ConstantPropertyVariableBuilder> properties;
    final Set<String> classifications;

    public ConstantPropertyVariableBuilder(String name, Object value, Binding binding, Collection<ConstantPropertyVariableBuilder> properties, Set<String> classifications) {
        this.name = name;
        this.value = value;
        this.binding = binding;
        this.properties = properties;
        this.classifications = classifications;
    }

    public ConstantPropertyVariableBuilder(String name, Object value, Binding binding) {
    	this(name, value, binding, new ArrayList<ConstantPropertyVariableBuilder>(), Collections.<String>emptySet());
    }

    public String getName() {
    	return name;
    }
    
	public ConstantPropertyVariable build(Variable parent) {
		return new ConstantPropertyVariable(parent, name, value, binding, properties, classifications);
	}
	
}
