package org.simantics.db.layer0.variable;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.common.adaption.SimpleAdapter;
import org.simantics.db.exception.AdaptionException;
import org.simantics.db.exception.AssumptionException;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.layer0.exception.MissingVariableException;

public class URIResourceVariableAdapter extends SimpleAdapter<Variable> {

	@Override
	public Variable adapt(ReadGraph g, Resource r) throws DatabaseException {
	    try {
	        return Variables.getVariable(g, r);
	    } catch (MissingVariableException e) {
            throw new AdaptionException("Variables.getVariable failed", e);
	    } catch (AssumptionException e) {
	        throw new AdaptionException("Variables.getVariable failed", e);
	    }
	}

}
